﻿using UnityEngine;
using System.Collections;

public class CharacterSelector : MonoBehaviour
{
    public CharacterControllerBase CurrentCharacter;

    public CharacterControllerBase[] Characters;
    public int CharacterIndex = 0;

    static CharacterSelector _inst;
    public static CharacterSelector Instance
    {
        get
        {
            return _inst;
        }
    }

    public void Start()
    {
        _inst = this;
        CurrentCharacter = Characters[CharacterIndex];
    }

    public bool ChangePressed = false;
    public void Update()
    {
        if(!ChangePressed && Input.GetKeyDown(KeyCode.V))
        {
            ChangePressed = true;
        }
        else if(ChangePressed && Input.GetKeyUp(KeyCode.V))
        {
            ChangePressed = false;
            var sprite = CurrentCharacter.gameObject.GetComponent<SpriteRenderer>();
            sprite.sortingOrder = 0;
            CharacterIndex = (CharacterIndex + 1) % Characters.Length;
            CurrentCharacter = Characters[CharacterIndex];
            sprite = CurrentCharacter.gameObject.GetComponent<SpriteRenderer>();
            sprite.sortingOrder = 1;
        }
    }

    public void SetPositions(Vector3 position)
    {
        foreach(var sprite in Characters)
        {
            sprite.gameObject.transform.position = position;
        }
    }
}
