﻿using UnityEngine;
using System.Collections;

public class EngineerController : CharacterControllerBase
{
    bool Pressed = false;
    protected override void InnerUpdate()
    {
        base.InnerUpdate();

        if (!Pressed && Input.GetKeyDown(KeyCode.C))
        {
            Pressed = true;
        }
        else if (Pressed && Input.GetKeyUp(KeyCode.C))
        {
            Pressed = false;
            var info = Controller.GetCurrentAnimatorStateInfo(0);
            if(info.IsName("EN_WalkUp") || info.IsName("EN_IdleUp"))
            {
                CastInDirection(Vector3.up);
            }
            else if (info.IsName("EN_WalkDown") || info.IsName("EN_IdleDown"))
            {
                CastInDirection(Vector3.down);
            }
            else if (info.IsName("EN_WalkLeft") || info.IsName("EN_IdleLeft"))
            {
                CastInDirection(Vector3.left);
            }
            else if (info.IsName("EN_WalkRight") || info.IsName("EN_IdleRight"))
            {
                CastInDirection(Vector3.right);
            }
        }
    }

    private void CastInDirection(Vector3 direction)
    {
        RaycastHit hitInfo;
        if (Physics.Raycast(gameObject.transform.position, direction, out hitInfo, 100f) &&
            hitInfo.collider.gameObject.GetComponent<EngineerConsole>() != null)
        {
            hitInfo.collider.gameObject.GetComponent<EngineerConsole>().Activate();
        }
    }
}
