﻿using UnityEngine;
using System.Collections;

public class MapTransition : MonoBehaviour
{
    public enum Direction
    {
        Top,
        Bottom,
        Left,
        Right
    }

    public Direction TargetDirection;

    void OnTriggerEnter(Collider collider)
    {
        CharacterControllerBase controller;
        if ((controller = collider.gameObject.GetComponent<CharacterControllerBase>()) != null)
        {
            MapNode nextMap = null;
            Vector3 newPosition = collider.gameObject.transform.position;
            switch (TargetDirection)
            {
                case Direction.Top:
                    nextMap = MapManager.Instance.CurrentMap.Top;
                    newPosition -= new Vector3(0, 580, 0);
                    break;
                case Direction.Bottom:
                    newPosition += new Vector3(0, 580, 0);
                    nextMap = MapManager.Instance.CurrentMap.Bottom;
                    break;
                case Direction.Left:
                    newPosition += new Vector3(580, 0, 0);
                    nextMap = MapManager.Instance.CurrentMap.Left;
                    break;
                case Direction.Right:
                    newPosition -= new Vector3(580, 0, 0);
                    nextMap = MapManager.Instance.CurrentMap.Right;
                    break;
            }
            if (nextMap != null)
            {
                CharacterSelector.Instance.SetPositions(newPosition);
                MapManager.Instance.LastPoint = newPosition;
                MapManager.Instance.SwitchMap(nextMap);
            }
        }
    }
}
