﻿using UnityEngine;
using System.Collections;

public class SecurityController : CharacterControllerBase
{
    public GameObject BeamUp;
    public GameObject BeamDown;
    public GameObject BeamLeft;
    public GameObject BeamRight;

    GameObject Beam;

    public float Time = -1f;

    bool Pressed = false;
    protected override void InnerUpdate()
    {
        base.InnerUpdate();

        if(Time > -1f)
        {
            Time -= UnityEngine.Time.deltaTime;
            if(Time < 0f)
            {
                Beam.SetActive(false);
                Time = -1f;
            }
        }

        if (CharacterSelector.Instance.CurrentCharacter != this) return;

        if (!Pressed && Input.GetKeyDown(KeyCode.C))
        {
            Pressed = true;
        }
        else if (Pressed && Input.GetKeyUp(KeyCode.C))
        {
            Pressed = false;
            var info = Controller.GetCurrentAnimatorStateInfo(0);
            Time = 0.25f;
            if (info.IsName("SO_WalkUp") || info.IsName("SO_IdleUp"))
            {
                CastInDirection(Vector3.up);
                Beam = BeamUp;
            }
            else if (info.IsName("SO_WalkDown") || info.IsName("SO_IdleDown"))
            {
                CastInDirection(Vector3.down);
                Beam = BeamDown;
            }
            else if (info.IsName("SO_WalkLeft") || info.IsName("SO_IdleLEft"))
            {
                CastInDirection(Vector3.left);
                Beam = BeamLeft;
            }
            else if (info.IsName("SO_WalkRight") || info.IsName("SO_IdleRight"))
            {
                CastInDirection(Vector3.right);
                Beam = BeamRight;
            }
            Beam.SetActive(true);
        }
    }

    private void CastInDirection(Vector3 direction)
    {
        RaycastHit hitInfo;
        if (Physics.Raycast(gameObject.transform.position, direction, out hitInfo, 100f, 1 << LayerMask.NameToLayer("Triggers")) &&
            hitInfo.collider.gameObject.GetComponent<SOTarget>() != null)
        {
            hitInfo.collider.gameObject.GetComponent<SOTarget>().Activate();
        }
    }
}
